# PhasicFlow: sortedPairs< executionSpace, idType >::pairAccessor Struct Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

sortedPairs< executionSpace, idType >::pairAccessor Struct Reference

## Public Types

using | PairType = typename sortedPairs::PairType

## Public Member Functions

INLINE_FUNCTION_HD uint32 | size () const
INLINE_FUNCTION_HD uint32 | loopCount () const
INLINE_FUNCTION_HD bool | isValid (uint32 i) const
INLINE_FUNCTION_HD PairType | getPair (uint32 i) const
INLINE_FUNCTION_HD bool | getPair (uint32 i, PairType &pair) const

## Public Attributes

uint32 | size_
ViewType1D< PairType, ExecutionSpace > | sortedParis_

## Detailed Description

### template<typename executionSpace, typename idType>
struct pFlow::sortedPairs< executionSpace, idType >::pairAccessor

Definition at line 51 of file sortedPairs.hpp.

## Member Typedef Documentation

## PairType

using PairType = typename sortedPairs::PairType

Definition at line 53 of file sortedPairs.hpp.

## Member Function Documentation

## size()

INLINE_FUNCTION_HD uint32 size | ( |  | ) | const

inline

Definition at line 60 of file sortedPairs.hpp.

References sortedPairs< executionSpace, idType >::pairAccessor::size_.

## loopCount()

INLINE_FUNCTION_HD uint32 loopCount | ( |  | ) | const

inline

Definition at line 63 of file sortedPairs.hpp.

References sortedPairs< executionSpace, idType >::pairAccessor::size_.

## isValid()

INLINE_FUNCTION_HD bool isValid | ( | uint32 | i | ) | const

inline

Definition at line 66 of file sortedPairs.hpp.

References sortedPairs< executionSpace, idType >::pairAccessor::size_.

## getPair() [1/2]

INLINE_FUNCTION_HD PairType getPair | ( | uint32 | i | ) | const

inline

Definition at line 69 of file sortedPairs.hpp.

References sortedPairs< executionSpace, idType >::pairAccessor::sortedParis_.

## getPair() [2/2]

INLINE_FUNCTION_HD bool getPair | ( | uint32 | i,
|  | PairType & | pair
| ) |  | const

inline

Definition at line 72 of file sortedPairs.hpp.

References sortedPairs< executionSpace, idType >::pairAccessor::size_, and sortedPairs< executionSpace, idType >::pairAccessor::sortedParis_.

## Member Data Documentation

## size_

uint32 size_

Definition at line 55 of file sortedPairs.hpp.

Referenced by sortedPairs< executionSpace, idType >::pairAccessor::getPair(), sortedPairs< executionSpace, idType >::pairAccessor::isValid(), sortedPairs< executionSpace, idType >::pairAccessor::loopCount(), and sortedPairs< executionSpace, idType >::pairAccessor::size().

## sortedParis_

ViewType1D<PairType,ExecutionSpace> sortedParis_

Definition at line 57 of file sortedPairs.hpp.

Referenced by sortedPairs< executionSpace, idType >::pairAccessor::getPair().

The documentation for this struct was generated from the following file:

- src/Interaction/contactLists/sortedPairs.hpp